<template>
  <section>
    <h2>3ème pilier</h2>
    <p>Le 3ème pilier est la prévoyance individuelle, basée sur l'épargne volontaire effectuée par les assurés, équivalent de l'assurance-vie française. </p>
    <div class="two-columns">
      <div class="two-columns--item">
        <p>Ici Alice va:</p>
        <ol class="info-nav">
          <li :class="{'info-strong': state == 0}">Saisir les informations concernant l’épargne 3a</li>
          <li :class="{'info-strong': state == 1}">Sauvegarder les informations</li>
        </ol>
        <NuxtLink v-if="state == 2" class="button--strong" tag="button" to="/synthese">Continuer ➜</NuxtLink>
      </div>
      <div class="two-columns--item">
        <loading :active.sync="isLoading" :is-full-page="fullPage" />
        <fieldset>
          <label for="solde">Solde actuel du compte</label>
          <div class="hint">50000</div>
          <input id="solde" type="text" v-model="solde"></input>
          <label for="amount">Montant des cotisations annuelles prévisionnelles</label>
          <div class="hint">10000</div>
          <input id="amount" type="text" v-model="amount"></input>
          <label for="rate">Taux d’intérêt prévisionnel</label>
          <div class="hint">0.15</div>
          <input id="rate" type="text" v-model="rate"></input>%
          <label for="paydate">Date souhaitée de versement du capital</label>
          <input id="paydate" type="date" v-model="paydate"></input>
          <label for="yesOrNo">Avez vous un compte de libre passage ?</label>
          <select disabled="true" name="yesOrNo" id="yesOrNo" v-model="yesOrNo">
            <option :value="true">Oui</option>
            <option :value="false">Non</option>
          </select>
        </fieldset>
        <template v-if="solde && amount && rate && paydate">
          <label></label>
          <button v-if="!isSaved" @click="onSave">2. Sauvegarder les infos</button>
        </template>
      </div>
    </div>
  </section>
</template>

<script>
  import Loading from 'vue-loading-overlay'
  import { mapMutations } from 'vuex'

  export default {
    components: {
      Loading,
    },
    data () {
      return {
        fullPage: false,
        isLoading: true,
        solde: null,
        amount: null,
        rate: null,
        paydate: null,
        yesOrNo: false,
      }
    },
    computed: {
      state() {
        if (this.isLoading && (!this.solde || !this.amount || !this.rate || !this.paydate)) return -1;
        if (!this.solde || !this.amount || !this.rate || !this.paydate) return 0;
        if (!this.isSaved) return 1;

        return 2;
      },
      savedSolde () {
        return this.$store.state.open3k.solde
      },
      savedAmount () {
        return this.$store.state.open3k.amount
      },
      savedRate () {
        return this.$store.state.open3k.rate
      },
      savedPaydate () {
        return this.$store.state.open3k.paydate
      },
      isSaved () {
        return (this.solde == this.savedSolde)
        && (this.amount == this.savedAmount)
        && (this.rate == this.savedRate)
        && (this.paydate == this.savedPaydate);
      }
    },
    mounted () {
      this.$nuxt.$emit('check-if-connected')
      this.$nuxt.$once('user-is-connected', this.init)
    },
    methods: {
      ...mapMutations({
        setSolde: 'open3k/setSolde',
        setAmount: 'open3k/setAmount',
        setRate: 'open3k/setRate',
        setPaydate: 'open3k/setPaydate',
      }),
      _getInfo() {
        return this.$api.get('/open3k/info')
      },
      _saveInfo(info) {
        return this.$api.post('/open3k/info', info)
      },
      init () {
        this._getInfo().then((info) => {
          this.solde = info.solde;
          this.amount = info.amount;
          this.rate = info.rate;
          this.paydate = info.paydate;
          this.setSolde(info.solde);
          this.setAmount(info.amount);
          this.setRate(info.rate);
          this.setPaydate(info.paydate);

          this.isLoading = false;
        })
      },
      onSave() {
        this.isLoading = true;

        this._saveInfo({
          solde: this.solde,
          amount: this.amount,
          rate: this.rate,
          paydate: this.paydate,
        }).then(() => {
          this.isLoading = false;
          this.setSolde(this.solde);
          this.setAmount(this.amount);
          this.setRate(this.rate);
          this.setPaydate(this.paydate);
        }, 300)
      },
      onGetInfo() {
        this.isLoading = true;

        this._getInfo().then((data) => {
          this.setCalculator(data);
          this.isLoading = false;
          this.data = data;
        }, 300)
      },
    }
  }
</script>
